@setlocal
@echo off

:: Command file to create a single zip file for FTP site or similar

:: Assumes the following 

:: The full path to current script with drive and trailing backslash
set SCRIPT_PATH=%~dp0
set ZIPEXE="%SCRIPT_PATH%installer\7za.exe"
set INSTALL_ZIP="%SCRIPT_PATH%p4train.zip"
set LOG="%SCRIPT_PATH%install-create.log"

echo Starting creation - logging to %LOG%
echo Starting creation>%LOG%

if exist %INSTALL_ZIP% (
    del %INSTALL_ZIP%
)
if not (%errorlevel%)==(0) set errstr=ERROR deleting zip file. && goto error

if not exist ..\p4.exe set errstr=ERROR - can't find p4.exe in parent directory! && goto error
if not exist ..\p4d.exe set errstr=ERROR - can't find p4d.exe in parent directory! && goto error

:: Update the latest depot zip file.
call zip_depots.bat>>%LOG% 2>&1

:: Add desired executables
call :zip_file ..\p4.exe
call :zip_file ..\p4d.exe
if exist ..\p4vinst.exe (   
    call :zip_file ..\p4vinst.exe
)
if exist ..\p4vinst64.exe (
    call :zip_file ..\p4vinst64.exe
)
call :zip_file ..\p4broker.exe
call :zip_file ..\svcinst.exe

pushd installer
if not (%errorlevel%)==(0) set errstr=ERROR in lower level directories. && goto error

call :zip_file PerforceTraining.zip
call :zip_file 7za.exe
call :zip_file install.bat
call :zip_file install_details.bat
call :zip_file recover.bat
call :zip_file server.bat
call :zip_file uninstall.bat
call :zip_file validate.bat

goto :finished

:zip_file
if not exist %1 set errstr=ERROR - can't find %1 to be compressed! && goto error
%ZIPEXE% a -tzip -bd %INSTALL_ZIP% %1>> %LOG% 2>&1
if not (%errorlevel%)==(0) set errstr=ERROR zipping file. && goto error
goto :eof

:zip_dir
%ZIPEXE% a -tzip -bd -r %INSTALL_ZIP% %1>> %LOG% 2>&1
if not (%errorlevel%)==(0) set errstr=ERROR zipping dir. && goto error
goto :eof

:error
echo.
echo %errstr%
echo %errstr%>> %LOG%
echo.

:finished
echo Finished - see log file %LOG%
popd
