@setlocal

:: This script installs the test perforce repository
:: for training purposes.

:: The root into which everything is installed - can be modified if you wish.
:: Passed to install_details.bat (and is mentioned in README.txt)
set INSTALL_PATH=c:\p4training

:: Find the root directory of this script - seems to work fine for UNC paths now as well as mapped SCRIPT_PATHs
set SCRIPT_PATH=%~dp0
ECHO SCRIPT_PATH is %SCRIPT_PATH%

set P4PORT=1666
set P4ROOT=%INSTALL_PATH%
set P4JOURNAL=%INSTALL_PATH%\logs\journal

rem If called from uninstall.bat then force uninstall
if (%1)==(uninstall) goto uninstall

mkdir %P4ROOT%
cd /d %P4ROOT%
if %ERRORLEVEL% GTR 0 (
    ECHO ERROR CD-ing to directory: %INSTALL_PATH%
    exit /b 1
)

mkdir checkpoints
mkdir logs

:: Remove existing installation
del/f/q db.* %P4JOURNAL%

:: The following are in case of a reinstall
if exist checkpoint (
    attrib -r checkpoint
)

:: Unzipper
copy "%SCRIPT_PATH%7za.exe" .
:: Other key files
copy "%SCRIPT_PATH%server.bat" .
copy "%SCRIPT_PATH%install_details.bat" .
copy "%SCRIPT_PATH%recover.bat" .
copy "%SCRIPT_PATH%uninstall.bat" .

:: This is the zip file containing the sample depot, checkpoint etc 
copy "%SCRIPT_PATH%PerforceTraining.zip" .

copy "%SCRIPT_PATH%p4.exe" .
copy "%SCRIPT_PATH%p4d.exe" .
copy "%SCRIPT_PATH%svcinst.exe" .

:: Copy p4broker.exe if found
if exist "%SCRIPT_PATH%p4broker.exe" (
    copy "%SCRIPT_PATH%p4broker.exe" .
)

:: Copy p4vinst.exe if found
if exist "%SCRIPT_PATH%p4vinst.exe" (
    copy "%SCRIPT_PATH%p4vinst.exe" .
)

:: Copy p4vinst64.exe if found
if exist "%SCRIPT_PATH%p4vinst64.exe" (
    copy "%SCRIPT_PATH%p4vinst64.exe" .
)

:: User can now remove the USB stick as all files are copied!
:: Rest of the work is done in this separate .bat file which is
:: not affected by the original source drive being unavailable.
call install_details.bat %INSTALL_PATH%

goto finish

:uninstall
%script_path%\install_details.bat %install_path% uninstall

:finish
cd \p4training

@endlocal
