@setlocal
@echo off

:: Command file to ensure PerforceTraining.zip is up-to-date

:: Assumes the following 

:: The full path to current script with drive and trailing backslash
set SCRIPT_PATH=%~dp0
set ZIPEXE="%SCRIPT_PATH%installer\7za.exe"
set TRAINING_ZIP="%SCRIPT_PATH%installer\PerforceTraining.zip"

del %TRAINING_ZIP%
if not (%errorlevel%)==(0) set errstr=ERROR deleting zip file. && goto error

pushd ..
if not (%errorlevel%)==(0) set errstr=ERROR in lower level directories. && goto error

:: This is the list of directories/files to zip up
call :zip_dir depots
call :zip_dir docs
call :zip_file checkpoint

goto :finished

:zip_file
%ZIPEXE% a -tzip %TRAINING_ZIP% %1
if not (%errorlevel%)==(0) set errstr=ERROR zipping file. && goto error
goto :eof

:zip_dir
%ZIPEXE% a -tzip -r %TRAINING_ZIP% %1
if not (%errorlevel%)==(0) set errstr=ERROR zipping dir. && goto error
goto :eof

:error
echo.
echo %errstr%
echo.

:finished
popd
